function [allfiltered] = applyfilterfftsame(I, allfilter, localHalfx, localHalfy, thresholdFactor);

nimage = size(I, 2);    % number of training images
norient = size(allfilter, 2);     % number of orientations
h = (size(allfilter{1}, 1)-1)/2;  % half size of filters
[sx, sy] = size(I{1});  % size of images
allfiltered = cell(nimage, norient);  % filtered images
for (i = 1 : nimage)
   fftI{i} = fft2(I{i}, sx+h+h, sy+h+h);
end
for  (o = 1 : norient)
   fftf{o} = fft2(allfilter{1, o}, sx+h+h, sy+h+h); 
end

for (i = 1 : nimage)
   tot = 0.;
   fftIi = fftI{i}; 
   for (o = 1 : norient)
      fftfo = fftf{o}; 
      out = ifft2(fftIi.*fftfo); 
      filtered = out(h+1:h+sx, h+1:h+sy); 
       re = real(filtered); im = imag(filtered); 
       energy = re.*re + im.*im;  % compute the local energy
       energy([1:h sx-h:sx],:) = 0.; energy(:,[1:h sy-h:sy]) = 0.; 
       allfiltered{i, o} = energy; 
       tot = tot + sum(sum(energy((h+1):(sx-h-1), (h+1):(sy-h-1))))/(sx-2*h-1)/(sy-2*h-1); 
   end
   ave = tot/norient; 
   for o = 1 : norient
       allfiltered{i, o} = allfiltered{i, o}/ave;  % normalizing by whitening
   end
   ClocalNormalizeDouble(sx, sy, norient, h, localHalfx, localHalfy, allfiltered(i, :), thresholdFactor); 
end

 
